<template>
  <div class="app-container">
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.barid" filterable placeholder="栏舍名称" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in houseNameList" :key="item.id" :label="item.bname" :value="item.id" />
      </el-select>
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" icon="el-icon-plus" class="success"  @click="handleCreate">新增</el-button>
      <el-button v-if="isRoleEdit" icon="el-icon-delete" class="danger"  @click="form_delete">删除</el-button>
      <!-- 临时注释 -->
      <!-- <el-button v-if="isRoleEdit" icon="el-icon-copy-document" class="copy"  @click="handleCopy">复制</el-button> -->
      <!-- 临时注释 -->
      <el-upload v-if="isRoleEdit" style="float: right;" :headers="headers" :data="uploadData" :action="uploadExcelUrl" :show-file-list="false" :before-upload="beforeImport" :on-success="handleImportSuccess">
        <el-button class="import" icon="el-icon-download" style="float: right;">导入</el-button>
      </el-upload>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export" icon="el-icon-upload2">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="handleExport(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="handleExport(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
      <el-button class="export" style="float: right;" @click="handleHistoryRecord">历史记录</el-button>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        @selection-change="handleSelectionChange"
        :max-height="myHeight"
      >
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="栏舍名称" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.barname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="标准分数(分)" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.standardscore }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牛头数(头)" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowsum }}</span>
          </template>
        </el-table-column>
        <el-table-column label="评分" align="center">
          <el-table-column label="1分(头)" min-width="65px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.score1 }}({{ scope.row.score1rate }}%)</span>
            </template>
          </el-table-column>
          <el-table-column label="2分(头)" min-width="65px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.score2 }}({{ scope.row.score2rate }}%)</span>
            </template>
          </el-table-column>
          <el-table-column label="3分(头)" min-width="65px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.score3 }}({{ scope.row.score3rate }}%)</span>
            </template>
          </el-table-column>
          <el-table-column label="4分(头)" min-width="65px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.score4 }}({{ scope.row.score4rate }}%)</span>
            </template>
          </el-table-column>
          <el-table-column label="5分(头)" min-width="65px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.score5 }}({{ scope.row.score5rate }}%)</span>
            </template>
          </el-table-column>
        </el-table-column>
        <el-table-column label="备注" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.remark }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作人" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.emp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作日期" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.operatetime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span v-if="isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>

    <!-- 新增/编辑 -->
    <el-dialog :fullscreen="dialogFull" :title="textMap[create.dialogStatus]" :visible.sync="create.dialogFormVisible" v-if='create.dialogFormVisible'  :close-on-click-modal="false" width="90%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[create.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-add">
        <el-form ref="temp" :rules="create.rules" :model="create.temp" label-position="right" label-width="150px" style="width: 100%;margin:0 auto 50px">
          <el-row>
            <el-col :span="24">
              <h3 style="width: 150px;text-align: right;">栏舍信息</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col v-if="create.dialogStatus=='create'" :span="6">
              <el-form-item label="栏舍名称：" prop="barid">
                <el-select ref="barid" v-model="create.temp.barid" filterable placeholder="栏舍名称" class="filter-item" style="width: 100%;" @change="changeBar">
                  <el-option v-for="item in houseNameList" :key="item.id" :label="item.bname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col v-else :span="12">
              <el-form-item label="栏舍名称：" prop="barname">
                <el-input ref="barname" v-model="create.temp.barname" disabled class="filter-item" placeholder="barname" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 150px;text-align: right;">评分</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="标准分数（分）：" prop="standardscore">
                <el-input ref="standardscore" v-model="create.temp.standardscore" class="filter-item" style="width: 100%;" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="牛头数（头）:" prop="cowsum">
                <el-input ref="cowsum" v-model="create.temp.cowsum" class="filter-item" style="width: 100%;" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="1分" prop="score1">
                <el-input ref="score1" v-model="create.temp.score1" class="filter-item" placeholder="牛头数" type="number" style="width: 100%;" @blur="blurScore" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="2分" prop="score2">
                <el-input ref="score2" v-model="create.temp.score2" class="filter-item" placeholder="牛头数" type="number" style="width: 100%;" @blur="blurScore" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="3分" prop="score3">
                <el-input ref="score3" v-model="create.temp.score3" class="filter-item" placeholder="牛头数" type="number" style="width: 100%;" @blur="blurScore" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="4分" prop="score4">
                <el-input ref="score4" v-model="create.temp.score4" class="filter-item" placeholder="牛头数" type="number" style="width: 100%;" @blur="blurScore" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="5分" prop="score5">
                <el-input ref="score5" v-model="create.temp.score5" class="filter-item" placeholder="牛头数" type="number" style="width: 100%;" @blur="blurScore" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 150px;text-align: right;">操作详情</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="操作人：" prop="emp">
                <el-select ref="emp" v-model="create.temp.emp" filterable placeholder="操作人" class="filter-item" style="width: 100%;" @blur="blurEmp">
                  <el-option v-for="item in create.noteTakerList" :key="item.myId" :label="item.emp" :value="item.emp" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="操作日期：" prop="operatetime">
                <el-date-picker v-model="create.temp.operatetime" type="date" placeholder="选择日期" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width: 100%;" :clearable="false" @change="changeOperatetime" />
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="备注：" prop="remark">
                <el-input ref="remark" v-model="create.temp.remark" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" placeholder="1-255字符" maxlength="255" class="filter-item" style="width: 100%;" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose" @click="create.dialogFormVisible = false;getList()">关闭</el-button>
          <el-button v-if="create.dialogStatus==='create'" class="save" :disabled="isokDisable" @click="createDataAgain()">确认新增</el-button>
          <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="save" :disabled="isokDisable" @click="create.dialogStatus==='create'?createData():updateData()">确认</el-button>
        </div>
      </div>
    </el-dialog>
    <!-- 历史记录 -->
    <el-dialog :fullscreen="dialogFull" :destroy-on-close="true" :visible.sync="historyRecord.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[historyRecord.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="historyRecord">
        <keep-alive>
          <component :is="historyRecord.myComponent" ref="historyRecord" />
        </keep-alive>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose cancelClose1" @click="historyRecord.dialogFormVisible = false; ">关闭</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, PostDataByName, failproccess, ExecDataByConfig, GetDataByNames, checkButtons } from '@/api/common'
import Cookies from 'js-cookie'
import { parseTime, json2excel } from '@/utils/index.js'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
import axios from 'axios'
import { getToken } from '@/utils/auth'
export default {
  name: 'DungScores',
  components: { Pagination },
  data() {
    return {
      dialogFull: false,
      isRoleEdit: [],
      requestParams: [
        { name: 'getBarListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') }},
        { name: 'getSysoptEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid'), 'inforname': 'times' }}
      ],
      houseNameList: [], // 栏舍名称
      frequencyList: [], // 班次

      table: {
        getdataListParm: {
          name: 'getDungscoreList',
          page: 1,
          offset: 1,
          pagecount: parseInt(Cookies.get('pageCount')),
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            times: '',
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },

      // 新增/编辑
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: { pastureid: Cookies.get('pastureid'), operatetime: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', times: '', standardscore: '', cowsum: '', score1: '', score2: '', score3: '', score4: '', score5: '', remark: '', ftid: '', ftname: '' },
        rules: {
          barid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          times: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          score1: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          score2: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          score3: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          score4: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          score5: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }]
        },
        // 操作人
        getdataListParm: {
          name: 'getDungscoreEmpHis',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        // 粪便评分参数
        getdataListParm2: {
          name: 'getDungAndBodyScore',
          page: 1,
          offset: 1,
          pagecount: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            date: ''
          }
        },
        noteTakerList: [] // 记录人
      },
      textMap: {
        create: '新增',
        update: '编辑',
        historyRecord: '历史记录'
      },
      historyRecord: {
        dialogFormVisible: false,
        dialogStatus: '',
        myComponent: null
      },
      requestParam: {},
      requestParam2: {},
      download: {
        getdataListParm: {
          name: 'getDungscoreList',
          page: 1,
          offset: 1,
          pagecount: 0,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            times: '',
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        list: []
      },
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      myHeight:document.documentElement.clientHeight - 85- 150 - 45
    }
  },
  computed: {
    // 设置请求头
    headers() {
      return {
        token: getToken()
      }
    },
    uploadData() {
      return {
        name: 'checkbarname,insertDungscoreUpload',
        importParams: '栏舍名称,1分（头）,2分（头）,3分（头）,4分（头）,5分（头）,备注,操作人,操作日期',
        sheetname: 'Sheet1',
        // 登录牧场
        pastureid: Cookies.get('pastureid'),
        // 日期参数
        dateParams: '操作日期',
        // 必填参数
        requiredParams: '栏舍名称,1分（头）,2分（头）,3分（头）,4分（头）,5分（头）',
        // 为数值的参数
        numParams: '1分（头）,2分（头）,3分（头）,4分（头）,5分（头）'
      }
    },
    // 设置上传地址
    uploadExcelUrl() {
      return Cookies.get('url') + 'authdata/ImportExcel'
    }
  },
  created() {
    this.getList()
    this.getDownList()
    this.getButtons()
  },

  methods: {
    getButtons() {
      const Edit = 'DungScores'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        this.houseNameList = response.data.getBarListEnable.list
        if (response.data.getSysoptEnable.list !== null) {
          for (let i = 1; i <= response.data.getSysoptEnable.list[0].inforvalue; i++) {
            const obj = {}
            obj.id = String(i)
            if (i == 1) { obj.name = '第一班' } else if (i == 2) { obj.name = '第二班' } else if (i == 3) { obj.name = '第三班' } else if (i == 4) { obj.name = '第四班' }else if (i == 5) { obj.name = '第五班' }else if (i == 6) { obj.name = '第六班' }
            this.frequencyList.push(obj)
          }
        } else {
          this.frequencyList = []
        }
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = this.table.getdataListParm.parammaps.inputDatetime[0] - 3600 * 1000 * 24
        var stop = this.table.getdataListParm.parammaps.inputDatetime[1] - 3600 * 1000 * 24
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = this.table.getdataListParm.parammaps.inputDatetime[0] + 3600 * 1000 * 24
        var stop = this.table.getdataListParm.parammaps.inputDatetime[1] + 3600 * 1000 * 24
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'score1rate', (parseFloat(response.data.list[i].score1) / parseFloat(response.data.list[i].cowsum) * 100).toFixed(2))
            this.$set(response.data.list[i], 'score2rate', (parseFloat(response.data.list[i].score2) / parseFloat(response.data.list[i].cowsum) * 100).toFixed(2))
            this.$set(response.data.list[i], 'score3rate', (parseFloat(response.data.list[i].score3) / parseFloat(response.data.list[i].cowsum) * 100).toFixed(2))
            this.$set(response.data.list[i], 'score4rate', (parseFloat(response.data.list[i].score4) / parseFloat(response.data.list[i].cowsum) * 100).toFixed(2))
            this.$set(response.data.list[i], 'score5rate', (100 - response.data.list[i].score1rate - response.data.list[i].score2rate - response.data.list[i].score3rate - response.data.list[i].score4rate).toFixed(2))
          }
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.barid = ''
      this.table.getdataListParm.parammaps.times = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.offset = 1
      this.getList()
    },

    // 新增
    resetTemp() {
      this.create.temp = { pastureid: Cookies.get('pastureid'), operatetime: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', times: '', standardscore: '', cowsum: '', score1: '', score2: '', score3: '', score4: '', score5: '', remark: '', ftid: '', ftname: '' }
    },
    blurEmp(item) {
      this.create.temp.emp = item.target.value
    },
    // 栏舍名称
    changeBar(item) {
      this.create.temp.barname = this.houseNameList.find(obj => obj.id === item).bname
      this.getRange()
    },
    changeOperatetime() {
      this.getRange()
    },
    //  粪便评分参数
    getRange() {
      this.create.getdataListParm2.parammaps.date = this.create.temp.operatetime
      this.create.getdataListParm2.parammaps.barid = this.create.temp.barid
      GetDataByName(this.create.getdataListParm2).then(response => {
        if (response.data.list !== null) {
          this.create.temp.standardscore = response.data.list[0].dungstandard
          this.create.temp.ftid = response.data.list[0].ftid
          this.create.temp.ftname = response.data.list[0].ftname
        } else {
          this.create.temp.standardscore = ''
          this.create.temp.ftid = ''
          this.create.temp.ftname = ''
        }
      })
    },
    // 操作人
    getNoteTakerList() {
      GetDataByName(this.create.getdataListParm).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            response.data.list[i].myId = i
          }
          this.create.noteTakerList = response.data.list
          console.log('记录人数据', response.data.list)
          console.log(this.create.noteTakerList)
        } else {
          this.create.noteTakerList = []
        }
      })
    },
    blurScore() {
      if (this.create.temp.score1 !== '' && this.create.temp.score2 !== '' && this.create.temp.score3 !== '' && this.create.temp.score4 !== '' && this.create.temp.score5 !== '') {
        this.create.temp.cowsum = parseInt(this.create.temp.score1) + parseInt(this.create.temp.score2) + parseInt(this.create.temp.score3) + parseInt(this.create.temp.score4) + parseInt(this.create.temp.score5)
      }
    },
    handleCreate() {
      console.log('点击了新增')
      this.resetTemp()
      this.getNoteTakerList()
      this.dialogFull = false
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
    },
    createData() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const score = /^\d*$/
          // 1分/2分/3分/4分/5分
          if (!score.test(parseFloat(this.create.temp.score1)) || !score.test(parseFloat(this.create.temp.score2)) || !score.test(parseFloat(this.create.temp.score3)) || !score.test(parseFloat(this.create.temp.score4)) || !score.test(parseFloat(this.create.temp.score5))) {
            this.$message({ type: 'error', message: '牛头数请输入大于等于0的整数', duration: 2000 })
            return false
          }

          this.requestParam.name = 'insertDungscore'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.emp == '') { this.create.temp.emp = Cookies.get('employename') }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.saveData()
            } else {
              const isRepeat = new RegExp('Duplicate entry :ds')
              if (isRepeat.test(response.data)) {
                this.$notify({ type: 'error', message: '同一栏舍不可重复录入', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
            }
          })
        }
      })
    },
    saveData() {
      this.requestParam2.name = 'insertDungandbodyhistory'
      this.create.temp.pastureid = Cookies.get('pastureid')
      this.create.temp.changetime = parseTime(new Date(), '{y}-{m}-{d} {h}:{i}:{s}')
      this.create.temp.species = 'fppf'
      this.create.temp.fourrate = ''
      this.create.temp.fourweight = ''
      this.requestParam2.parammaps = this.create.temp
      PostDataByName(this.requestParam2).then(response => {
        console.log('新增保存发送参数', this.requestParam1)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.create.dialogFormVisible = false
          this.getList()
        } else {
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        }
      })
    },
    createDataAgain() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const score = /^\d*$/
          // 1分/2分/3分/4分/5分
          if (!score.test(parseFloat(this.create.temp.score1)) || !score.test(parseFloat(this.create.temp.score2)) || !score.test(parseFloat(this.create.temp.score3)) || !score.test(parseFloat(this.create.temp.score4)) || !score.test(parseFloat(this.create.temp.score5))) {
            this.$message({ type: 'error', message: '牛头数请输入大于等于0的整数', duration: 2000 })
            return false
          }

          this.requestParam.name = 'insertDungscore'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.emp == '') { this.create.temp.emp = Cookies.get('employename') }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.saveData()
              this.resetTemp()
              this.getList()
              this.getNoteTakerList()
            } else {
              const isRepeat = new RegExp('Duplicate entry :ds')
              if (isRepeat.test(response.data)) {
                this.$notify({ type: 'error', message: '同一栏舍不可重复录入', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
            }
          })
        }
      })
    },

    // 编辑
    handleUpdate(row) {
      console.log('点击了编辑', row)
      row.barid = String(row.barid)
      row.score1 = String(row.score1)
      row.score2 = String(row.score2)
      row.score3 = String(row.score3)
      row.score4 = String(row.score4)
      row.score5 = String(row.score5)
      this.create.temp = Object.assign({}, row)
      this.create.temp.id = row.id

      this.getNoteTakerList()
      this.dialogFull = false
      this.create.dialogStatus = 'update'
      this.create.dialogFormVisible = true
    },
    updateData() {
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const score = /^\d*$/
          // 1分/2分/3分/4分/5分
          if (!score.test(parseFloat(this.create.temp.score1)) || !score.test(parseFloat(this.create.temp.score2)) || !score.test(parseFloat(this.create.temp.score3)) || !score.test(parseFloat(this.create.temp.score4)) || !score.test(parseFloat(this.create.temp.score5))) {
            this.$message({ type: 'error', message: '牛头数请输入大于等于0的整数', duration: 2000 })
            return false
          }

          this.requestParam.name = 'updateDungscore'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.emp == '') { this.create.temp.emp = Cookies.get('employename') }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.saveData()
            } else {
              const isRepeat = new RegExp('Duplicate entry :ds')
              if (isRepeat.test(response.data)) {
                this.$notify({ type: 'error', message: '同一栏舍不可重复录入', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
            }
          })
        }
      })
    },

    // 删除
    handleRowDelete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteDungscore'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.getList()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    handleSelectionChange(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    form_delete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择粪便评分', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'deleteDungscore', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    },
    // 改成多条，后端接口未改正确，先注释
     handleCopy() {
      console.log('点击了复制')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择粪便评分', duration: 2000 })
      } else  {
        MessageBox.confirm('是否确认复制此信息?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {

          var send_data = {
            "common":{"returnmap":"0"},
            "data":[
              {
                "name":"insertSpotList",
                "resultmaps":{
                  "list":this.selectList
                },
                "children":[
                    {
                      "name":"copyDungscore","type":"e",
                      "parammaps":{
                        "id": "@insertSpotList.id",
                        "pastureid":"@insertSpotList.pastureid"
                      }
                    }
                ]
              }
            ]
          }
          ExecDataByConfig(send_data).then(response => {
            if (response.msg === 'fail') {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        }).catch(() => {
          this.$message({ type: 'info', message: '已取消复制' })
        })
      }
    },


    // 导出
    handleExport(item) {
      if (item == 1) {
        console.log('点击了导出模板')
        const requestParam = this.requestParam
        const url = Cookies.get('url') + 'file/导入导出模板/栏舍生产/粪便评分导入模板.xlsx' // 请求下载文件的地址
        console.log(url)
        axios({
          method: 'GET',
          url: url,
          data: requestParam,
          headers: { token: getToken(), optname: 'insertcustomdoc' },
          responseType: 'blob'
        }).then(res => {
          if (!res) return
          this.percentage = 99
          setTimeout(() => {
            this.isPercentage = false
          }, 2000)
          const blob = new Blob([res.data], {
            type: 'application/octet-stream;charset=utf-8'
          })
          const url = window.URL.createObjectURL(blob)
          const aLink = document.createElement('a')
          aLink.style.display = 'none'
          aLink.href = url
          const docname = '粪便评分导入模板.xlsx'
          aLink.setAttribute('download', docname) // 下载的文件
          document.body.appendChild(aLink)
          aLink.click()
          document.body.removeChild(aLink)
          window.URL.revokeObjectURL(url)
        })
      } else {
        console.log('点击了导出数据')
        this.download.getdataListParm.parammaps = this.table.getdataListParm.parammaps
        if (this.download.getdataListParm.parammaps.inputDatetime !== '' && this.download.getdataListParm.parammaps.inputDatetime !== null) {
          this.download.getdataListParm.parammaps.startTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
          this.download.getdataListParm.parammaps.stopTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
        } else {
          this.download.getdataListParm.parammaps.inputDatetime = ''
          this.download.getdataListParm.parammaps.startTime = ''
          this.download.getdataListParm.parammaps.stopTime = ''
        }
        GetDataByName(this.download.getdataListParm).then(response => {
          if (response.data.list !== null) {
            this.download.list = response.data.list
          } else {
            this.download.list = []
          }
          var excelDatas = [
            {
              tHeader: ['栏舍名称', '标准分数（分）', '牛头数（头）', '1分（头）', '2分（头）', '3分（头）', '4分（头）', '5分（头）', '备注', '操作人', '操作日期'],
              filterVal: ['barname', 'standardscore', 'cowsum', 'score1', 'score2', 'score3', 'score4', 'score5', 'remark', 'emp', 'operatetime'],
              tableDatas: this.download.list,
              sheetName: 'Sheet1'
            }
          ]
          json2excel(excelDatas, '粪便评分', true, 'xlsx')
        })
      }
    },

    beforeImport(file) {
      const isLt2M = file.size / 1024 / 1024 < 2
      if (!isLt2M) {
        this.$message.error('上传文件大小不能超过 2MB!')
      }
      return isLt2M
    },
    handleImportSuccess(res, file) {
      this.getList()
      if (res.msg === 'ok') {
        this.$message({ title: '成功', message: '导入成功:' + res.data.success + '条!', type: 'success', duration: 2000 })
        if (res.data.err_count > 0) {
          this.$notify({ title: '失败', message: '导入失败:' + res.data.err_count + '条!', type: 'danger', duration: 2000 })
           import('@/vendor/Export2Excel').then(excel => {
             const list1 = res.data.result
             const tHeader = [
               '栏舍名称', '1分（头）', '2分（头）', '3分（头）', '4分（头）', '5分（头）', '备注', '操作人', '操作日期', '错误信息'
             ]
             const filterVal = [
               '栏舍名称', '1分（头）', '2分（头）', '3分（头）', '4分（头）', '5分（头）', '备注', '操作人', '操作日期', 'error_msg'
             ]
             const data1 = this.formatJson(filterVal, list1)
             excel.export_json_to_excel({ header: tHeader, data: data1, filename: '粪便评分导入报错信息', autoWidth: true, bookType: 'xlsx' })
           })
        }
      } else {
        this.$notify({ title: '失败', message: '上传失败', type: 'danger', duration: 2000 })
      }
    },
    formatJson(filterVal, jsonData) {
      return jsonData.map(v =>
        filterVal.map(j => {
          if (j === 'timestamp') {
            return parseTime(v[j])
          } else {
            return v[j]
          }
        })
      )
    },
    handleHistoryRecord() {
      console.log('点击历史记录')
      this.dialogFull = false
      this.historyRecord.dialogStatus = 'historyRecord'
      this.historyRecord.dialogFormVisible = true
      const vue = this
      var myComponent = () => import('./historyRecord.vue')
      return vue.historyRecord.myComponent = myComponent
    }

  }
}
</script>
